
###
###       (  , -  ..)
###


###  
proc mc:phase {} {
  global mc
  return $mc(phase)
}

###  theme- (type: m - mage, a - main<ct>, h - help<cth>, o - com<cto>, f - affect<ctf>)
proc mcmsg {type index {add ""}} {
  global ctm ct cth cto ctf
  append index $add
  switch -- $type {
    m { if {[info exist ctm($index)]} { return $ctm($index) } }
    a { if {[info exist ct($index)]}  { return $ct($index) } }
    h { if {[info exist cth($index)]} { return $cth($index) } }
    o { if {[info exist cto($index)]} { return $cto($index) } }
    f { if {[info exist ctf($index)]} { return $ctf($index) } }
  }
  putlog "!ERROR! mcmsg $type $index"
  return "#mcmsg#error#"
}
###     
proc mfrm {{add ""}} {
  global type
  if { $add != "" } { set add ".$add" }
  return [mcmsg m $type $add]
}
proc afrm {frm {add ""}} {
  if { $add != "" } { set add ".$add" }
  return [mcmsg a $frm $add]
}
proc hfrm {frm {add ""}} {
  if { $add != "" } { set add ".$add" }
  return [mcmsg h $frm $add]
}
proc ofrm {frm {add ""}} {
  if { $add != "" } { set add ".$add" }
  return [mcmsg o $frm $add]
}
proc ffrm {{add ""}} {
  global aid
  if { $add != "" } { set add ".$add" }
  return [mcmsg f $aid $add]
}


###    
proc mc:sex {args} {
    set ret ""
    foreach id $args {
        lappend ret [mc:getstat sex $id]
    }

    return $ret
}

###   
proc mc:nlog {h c} {
  global mc
  set fid [open $mc(file.nlog) a+]
  puts $fid "[clock format [expr [unixtime] + $mc(timeshift)] -format {%d.%m/%H:%M:%S}] #$h# $c"
  close $fid
}


proc mc:ispublicon {} {
  global mc
  if { ![info exist mc(bot.public)] || $mc(bot.public) == "" || ![islinked $mc(bot.public)] } { return 0 }
  if { ![botonchan $mc(chan)] } { return 1 }
  if { [info exist mc(bot.pub.nick)] && $mc(bot.pub.nick) != "" && ![onchan $mc(bot.pub.nick) $mc(chan)] } { return 0 }
  return 1
}

proc mc:dcclogcmd {h cm t} { putloglev c *0 "#$h# $cm $t" }

proc cleartimers {} {
    foreach e [utimers] {
        if { [string match "*mc:*" $e] } {
            killutimer [lindex $e 2]
        }
    }
}

proc mc:timer {mode name {sec 0} {code 0}} {
  global mctimers

  switch -- $mode {
    "-start" {
      if { $name == "all" } { return 0 }
      mc:timer -stop $name
      set mctimers($name) [utimer $sec $code]
      return 1
    }
    "-stop" {
      if { ![array exist mctimers] } { return 0 }

      if { $name == "all" } {
        foreach name [array names mctimers] {
          mc:timer -stop $name
        }
        return 1
      }

      if { ![info exist mctimers($name)] } { return 0 }

      foreach tid $mctimers($name) {
        foreach tmr [utimers] {
          if { [lindex $tmr 2] == $tid } { killutimer $tid }
        }
      }

      unset mctimers($name)
    }
    "-clear" {
      if { ![array exist mctimers] } { return 0 }
      if { $name == "all" } {
        unset mctimers
        return 1
      }
      if { ![info exist mctimers($name)] } { return 0 }
      unset mctimers($name)
    }
    "-add" {
      if { $name == "all" } { return 0 }
      if { ![array exist mctimers] || ![info exist mctimers($name)] } { set mctimers($name) "" }
      lappend mctimers($name) [utimer $sec $code]
      return 1
    }
  }
}


proc mcu:checkmoderate {} {
    global mc noreg mcr

    if { [string first "m" [getchanmode $mc(chan)]] != -1 && ($noreg == 1 || ![array exists mcr]) } {
        mc:pushmode -m
    }
    foreach e [utimers] {
        if { [string match "*mcu:checkmoderate*" $e] } {
            killutimer [lindex $e 2]
        }
    }
}

proc mc:msg {h w} {
    global mc mctn mctp mcoptions

    set id [mc:makeid $h]

#    if { ![info exists mcoptions(sendlist)] || $mcoptions(sendlist) == 0 } {
#        set w [randrussian $w]
#    }
 # set w [encoding convertto koi8-r [encoding convertfrom cp1251 $w]]
    if {[string first ":" $id] != -1} {
		::arena::BotNet::msg $id "\00310$w"
		return
    }

    if { [array exist mctn] } {
        foreach nn [array names mctn] {
            if { $mctn($nn) == $id && $mctp($nn) != "" } {
                if { [valididx $nn] } {
					     if {[mc:modeok $id "koi-dcc"]} { 
					       set w [encoding convertto koi8-r [encoding convertfrom cp1251 $w]]
					     }						
                    putidx $nn "10$w\r"
                    return
                } else {
                    unset mctn($nn)
                }
            }
        }
    }
    if { [mc:checkflag "F"] } {
        putquick "PRIVMSG $h :10$w"
    } else {
        putserv "PRIVMSG $h :10$w"
    }
}

proc mc:pushmode {m {w ""}} {
  global mc

  pushmode $mc(chan) $m $w
  ::arena::BotNet::pushmode $m $w
  
#  if {[islinked $mc(bot.public)] && [isop $mc(bot.public) $c]} {
#    putbot $mc(bot.public) "ap_pushmode $c $m [tobotnet [split $w]]"
#  } else { }
}

proc mc:qpushmode {m {w ""}} {
  global mc

  putquick "MODE $mc(chan) :$m $w"
  ::arena::BotNet::qpushmode $m $w
}       

proc mc:say {w} {
    global mc mcoptions roundlines
    if { [info exists roundlines] } { incr roundlines 1 }
	 
	 ::arena::BotNet::say "\00310$w" 	 
    set w "PRIVMSG $mc(chan) :10$w"
    if {[mc:ispublicon]} {
      putbot $mc(bot.public) "ap_say [tobotnet [split $w]]"
    } {
      puthelp $w
    }
}

proc mc:tsay {h w} {
    global mc mcoptions
	 
	 ::arena::BotNet::say "\00310$h\002: \002$w" 
    set w "PRIVMSG $mc(chan) :10$h: $w"
    if {[mc:ispublicon]} {
      putbot $mc(bot.public) "ap_say [tobotnet [split \"10$h: $w\"]]"
    } elseif { [mc:checkflag "F"] } {
      putquick $w
    } else {
      putserv $w
    }
}

proc mc:notice {h w} {
    global mc
    set id [mc:makeid $h]
  
    if {[string first ":" $id] != -1} {
		::arena::BotNet::notice $h "\00310$w"
		return
    }	 

    if { [mc:checkflag "F"] } {
        putquick "NOTICE $h :10$w"
    } else {
        putserv "NOTICE $h :10$w"
    }
}

###  1,      
proc mc:ondcc {id} {
    global mc mctn mctp

    foreach nn [array names mctn] {
        if {$mctn($nn) == $id && $mctp($nn) != ""} {
            return 1
        }
    }

    return 0
}

###  1     
proc mc:onbotnet {id} {
  if {[string first ":" $id] == -1} { return 0 } { return 1 }
}

###  1        
proc mc:onbotnetexist {id} {
  global mc
  if { ![mc:onbotnet $id] } { return 0 }
  if { ![info exist mc(ident)] || [lsearch -exact $mc(ident) $id] == -1 } { return 0 }
  return 1
} 

###   ,      
proc mc:channicks {} {
  global mc
  set ret ""
  foreach nick [chanlist $mc(chan)] {
    lappend ret $nick  
  }
  if {[info exist mc(ident)]} {
	 foreach nick $mc(ident) {
		if {[mc:onbotnet $nick]} { lappend ret $nick }
	 }
  } 
  return $ret
}

proc mc:tolat {string} {
    set out ""
    for {set j 0} {$j < [string length $string]} {incr j} {
        switch -- [string index $string $j] {
             { set out "${out}a" }
             { set out "${out}e" }
             { set out "${out}o" }
             { set out "${out}p" }
             { set out "${out}c" }
             { set out "${out}x" }
             { set out "${out}b" }
             { set out "${out}k" }
             { set out "${out}m" }
             { set out "${out}h" }
             { set out "${out}t" }
            default { set out "$out[string index $string $j]" }
        }
    }
    return $out
}

###  1,       0
proc mc:moderated {} {
    global mc

    if {[string first "m" [getchanmode $mc(chan)]] != -1} {
        return 1
    }
    return 0
}

###   ,    ,   ,    
proc mc:checkvoices {} {
    global mc mcr liv

    utimer 15 { mc:checkvoices }
    if { $mc(phase) < 1 } {
      set voicelist [array names mcr]
    }	 {
		set voicelist [array names liv]
    }
	 set avoice ""
    foreach e $voicelist {
      if {[arena::BotNet::isbotnet $e]} continue
      set nick1 [ms:dfl [mc:getstat nick $e]]
      set nick2 [ms:dfl $e]
	   set found 0
	   foreach vnick [chanlist $mc(chan)] {
 	     set rnick [tolower $vnick]
		  if { $rnick == $nick1 || $rnick == $nick2 } {
			 if {![isvoice $vnick $mc(chan)]} { mc:pushmode +v $vnick }
			 lappend avoice $vnick
			 break
		  }
		}            
    }
	 foreach vnick [chanlist $mc(chan)] {
		if {[lsearch -exact $avoice $vnick] == -1 && [isvoice $vnick $mc(chan)]} { mc:pushmode -v $vnick}
	 }
    
}

###     
proc mc:usersonchan {} {
    global mc

    set users 0
    foreach e [chanlist $mc(chan)] {
        incr users
    }
    return $users
}

proc mc:ismaster {hand} {
    global mc

    if {("[info procs auth:check]" != "") && (![auth:check $hand])} { return 0 }
    if {[regexp "m" "[chattr $hand]"] || [regexp "m" "[chattr $hand $mc(chan)]"]} { return 1 }
    return 0
}

proc mc:findonchan {name} {
    #putlog "MC:findonchan: $name"
    global mc

    if {![validchan $mc(chan)]} { return $name }

    foreach e [chanlist $mc(chan)] {
        if {[tolower $e] == [tolower $name]} {
            #putlog "FINDONCHAN : $e"
            return $e
        }
    }
    return $name
}

###   [expr]     -    (  ).
proc expr2 {size args} {
     if {$size == "-"} {
         return [expr $args]
     } else {
         return [format "%.${size}f" [expr $args]]
     }
}

###   
proc mc:rand {size} {
    return [expr round(rand() * ($size-1)) + 1]
}

proc min {a b} {
    if {$a < $b} {
        return $a
    } else {
        return $b
    }
}

proc max {a b} {
    if {$a > $b} {
        return $a
    } else {
        return $b
    }
}

proc mc:checkflag {fl} {
    global mc

    if {[string first $fl $mc(flags)] != -1} {
        return 1
    } else {
        return 0
    }
}

proc mc:checkin {f w} {
    if {[string length $f] != 1} { return 0 }
    if {[string first $f $w] == -1} { return 0 }

    return 1
}

proc mc:nickexp {} {
    global mc mcs


    set curtime [unixtime]
    putlog " Check NickExp... Current time: [clock format $curtime -format "\[%d.%m.%Y %H:%M:%S\]"]"
    set fid [open $mc(file.nexp) a+]

    foreach e [array names mcs] {
        set g [expr 10 + [mc:getstat remort $e] * 100 + [mc:getstat level $e] * 10]
        if {[mc:getstat nodrop $e] != 1 && (([mc:getstat ltime $e] != 0 && [expr $curtime - [mc:getstat ltime $e]] > [expr 86400 * $g]) || ([mc:getstat ltime $e] == 0 && [expr $curtime - [mc:getstat ctime $e]] > [expr 86400 * $g]))} {
            set clf [clock format [expr [mc:getstat ctime $e] + $mc(timeshift)] -format "\[%d.%m.%Y %H:%M:%S\]"]
            putlog [format "  Nick Expire: \"%-20s\" Last game: %s Reg date: %s" [ms:dfl $e] [clock format [expr [mc:getstat ltime $e] + $mc(timeshift)] -format "\[%d.%m.%Y %H:%M:%S\]"] $clf]
            puts $fid "$e $mcs($e)"
            mc:delnickcom $e
            unset mcs($e)
            if {([info exist mc(ident)]) && ([lsearch -exact $mc(ident) $e] != -1)} {
                set nn [lsearch -exact $mc(ident) $e]
                set mc(ident) [lreplace $mc(ident) $nn $nn]
            }
        }
    }

    close $fid
}

proc mc:teamexp {} {
    global mc mco

    set curtime [unixtime]
    putlog " Check TeamExp... Current time: [clock format $curtime -format "\[%d.%m.%Y %H:%M:%S\]"]"

    foreach cid [array names mco] {
        set g 15
        if {[expr $curtime - [mc:mcomget $cid 5]] > [expr 86400 * $g]} {
            putlog [format "  Nick Expire: \"%-30s\" Last game: %s" [ms:dfl $cid] [clock format [expr [mc:mcomget $cid 5] + $mc(timeshift)] -format "\[%d.%m.%Y %H:%M:%S\]"]]
            unset mco($cid)
        }
    }
}

proc mc:diex {s} {
    if {[string first x $s]==-1} { return $s }
    set min [expr [lindex [split $s x] 0] * 100]
    set max [expr [lindex [split $s x] 1] * 100]

    set result [expr ([rand [expr $max - $min + 1]] + $min) / 100.0]

    return $result
}

proc mc:die {s} {
    set t1 [split $s +]

    if { [llength $t1] == 1 } {
        set tmp [split $s d]
        set res 0.0
    } else {
        set tmp [split [lindex $t1 0] d]
        set res [expr [lindex $t1 1] * 100.0]
    }

    for { set i 1 } { $i <= [lindex $tmp 0] } { incr i } {
        set res [expr $res + [rand [expr [lindex $tmp 1] * 100.0]] + 1]
    }

    set res [expr $res / 100.0]

    return $res
}

proc mc:emailrules {n uh h t} {
    global mc
    if {![mc:ismaster $h]} { return }

    exec /bin/mail -s "IRC-Arena $mc(ver) Rules" [lindex $t 1] < $mc(rules)
    mc:msg $n "email send"
}

proc mc:mreset {n uh h t} {
    global mc
    if {![mc:ismaster $h]} { return }
    mc:setbinds [lindex $t 1]
    puthelp "NOTICE $n :   4$mc(chan)"
}

proc mc:fuck {t} {
    regsub -all " " $t ":fuckspace:" t;
    return $t
}

proc mc:unfuck {t} {
    regsub -all ":fuckspace:" $t " " t;
    return $t
}

proc mc:rules {n uh h c t} {
    global mc
    putlog "<<$n>> send rules..."
    dccsend $mc(rules) $n
}

proc mc:pdcc {n uh h c t} {
    global mc

    putquick "PRIVMSG $n :\001DCC CHAT chat [myip] $mc(dccport2)\001"
}

proc xformat {str sex args} {
    for {set j 1} {$j <= [llength $sex]} {incr j} {
        set tmp "&s${j}:"
        while {[string first $tmp $str] != -1} {
            set i1 [string first $tmp $str]
            set i2 [string first : $str [expr $i1 + 4]]
            set i3 [string first : $str [expr $i2 + 1]]
            set i4 [string first : $str [expr $i3 + 1]]
            if { $i1 == -1 || $i2 == -1 || $i3 == -1 || $i4 == -1 } {
                putlog "xformatbug: $str"
                break
            }

            switch -- [lindex $sex [expr $j - 1]] {
                0 { set end [string range $str [expr $i1 + 4] [expr $i2 - 1]] }
                1 { set end [string range $str [expr $i2 + 1] [expr $i3 - 1]] }
                default { set end [string range $str [expr $i3 + 1] [expr $i4 - 1]] }
            }
            set str [string replace $str $i1 $i4 $end]
        }
    }
    set end ""
    foreach nn $args {
        set end [lappend end $nn]
    }
    if { [catch {set end [eval "format \$str $end"]} errstr] } {
      putlog "[red]ERROR in xformat:[cl]"
      putlog "err: $errstr"
      putlog "frm: $str"
      putlog "arg: $args"
      putlog "[red]End error report.[cl]"
      set end "#error#"
    }
    return $end
}


proc mc_command {h i a} {
    global owner

    if {[lsearch -exact [string tolower $owner] [string tolower $h]] == -1 } {
      putidx $i "negative."
    } {
      putlog "MC: [eval mc:$a]"
    }
}

proc mc_set {h i a} {
    global mco mcs mc ct cth ctm mcr mcc mce min ts tl ti tv th twis ta tg te todo liv param nnick prc hitten noreg countr countt
    global mg mr race prof
    global owner

    if {[lsearch -exact [string tolower $owner] [string tolower $h]] == -1 } {
      putidx $i "negative."
      return
    }
    if {[llength [split $a]]==1} {
        set asd $[join [lindex [split $a] 0]]
        eval "set asd $asd"
        putlog "MC: $asd"
    } else {
        putlog "MC: [set [join [lindex [split $a] 0]] [join [lrange [split $a] 1 end]]]"
    }
}

bind dcc n mc mc_command
bind dcc n ms mc_set


###  $id   ,   = 100,   .
proc mc:delnickcom {id} {
    global mc mcs mco

    foreach cid [array names mco] {
        set access [mc:mcomget $cid 1]
        set deleted 0
        for { set j 0 } { $j < [llength $access] } { incr j } {
            if { [lindex [lindex $access $j] 0] == $id && [lindex [lindex $access $j] 1] == 100 } {
                unset mco($cid)
                set deleted 1
                putlog "DELTEAM $cid"
                break
            } elseif { [lindex [lindex $access $j] 0] == $id } {
                set access [lreplace $access $j $j]
            }
        }
        if { $deleted == 0 } {
            mc:mcomset $cid 1 $access
        }
    }
}

proc mc:createlist {} {
    global mc mcr liv

    set mc(list) ""

    set lastnum 1
    foreach tid [array names mcr] {
        if { $lastnum < $mcr($tid) } { set lastnum $mcr($tid) }
    }

    set nocomlist ""
    for { set i 1 } { $i <= $lastnum } { incr i } {
        foreach id [array names liv] {
            if { $mcr($id) == $i } {
              if { [mc:reg:getstat isnocom $id] } {
                lappend nocomlist $id
              } {
                lappend mc(list) $id
              }
            }
        }
    }

    foreach id $nocomlist { lappend mc(list) $id }
#    putlog "LIST: [ms:dfl $mc(list)]"
}

proc mc:createtopnicks {} {
    global mcs mc prof race topnicks

#    if { $mc(topsize) == 0 } { return }

    mc:log "Calculate experience top..."

    if {[array exist topnicks]} { unset topnicks }
    foreach prf [array names prof] {
      set topnicks($prf) ""
      set list ""
      foreach id [array names mcs] {
        if { [mc:getstat prof $id] != $prf } { continue }
        if { [string index [mc:getstat pass $id] 0] == "-" } { continue }
        set str [mc:getstat level $id]
        if { [string length $str] == 1 } { set str "0$str" } { set str "$str" }
        set rstr [mc:getstat remort $id]
        if { [string length $rstr] == 1 } { set rstr "0$rstr" } { set rstr "$rstr" }
        set estr [mc:getstat exp $id]
        while { [string length $estr] != 10 } {
          set estr "0$estr"
        }
        set str "$rstr$str$estr"
        lappend list "$str $id"
      }
      set list [lsort -ascii -decreasing -index 0 $list]
      foreach rec $list {
          lappend topnicks($prf) [lindex $rec 1]
      }
   }
}

proc mc:dellogs {mi ho da mo ye} {
    global logfile-suffix username
    putlog "MC:dellogs: $mi $ho $da $mo $ye"

    deletelogs "logs/arena.log" ${logfile-suffix} [mc:config:get keeplogs] 9
    deletelogs "logs/${username}.log"  ${logfile-suffix} [mc:config:get keeplogs] 9
}

###   $j    $log   $suffix,  $i .
### $log    -  ,  
### $suffix -  
### $i      -  ,   
### $j      -  ,   

proc deletelogs {log suffix i j} {
    set curtime [clock seconds]
    while {[clock format $curtime -format "%S"] != 0} { incr curtime -1 }
    while {[clock format $curtime -format "%M"] != 0} { incr curtime -60 }
    while {[clock format $curtime -format "%H"] != 0} { incr curtime -3600 }

    putlog "Start deleting logs: [clock format $curtime -format "%d%b%Y ! %Y%m%d"]"

    for {} {$i > 0} {incr i -1} {
        set curtime [expr $curtime - 86400]
    }

    for {} {$j > 0} {incr j -1} {
        set filename "$log[clock format $curtime -format $suffix]"
        if {[file exists $filename]} {
            putlog "  Delete: $filename"
            file delete $filename
        }
        set curtime [expr $curtime - 86400]
    }

    putlog "Deleting logs complete"
}

###      4   
proc mc:backupbase {mi ho da mo ye} {
    global mc mcs mco

    if { $mc(backupbase) == 0 || [expr $ho / $mc(backupbase)] != [expr 1.0 * $ho / $mc(backupbase)] } {
        return
    }

    set number [expr ($ho + $mc(backupbase)) / $mc(backupbase)]

    mc:log "Backup base files ($number) [clock format [unixtime] -format "\[%d.%m.%Y %H:%M:%S\]"]"

    ###  
    set fid [open "$mc(file.base).$number.backup" w]
    if { [array exists mcs] } {
        foreach e [array names mcs] { puts $fid "$e $mcs($e)" }
    }
    close $fid

    ###  
    set fid [open "$mc(file.coms).$number.backup" w]
    if { [array exists mco] } {
        foreach e [array names mco] { puts $fid "$e $mco($e)" }
    }
    close $fid
}



proc quicksort {ls count} {
    global quicklist

    set quicklist $ls
    putlog "STR: $quicklist"
    putlog "END: [qs 0 [expr $count - 1]]"
}

proc qs {left right} {
    global quicklist

    set i $left
    set j $right
    set x [lindex $quicklist [expr ($left + $right) / 2]]

    while {$i <= $j} {
        while {[lindex $quicklist $i] < $x && $i < $right} { incr i +1 }
        while {[lindex $quicklist $j] > $x && $j > $left}  { incr j -1 }

        if {$i <= $j} {
            set y [lindex $quicklist $i]
            set quicklist [lreplace $quicklist $i $i [lindex $quicklist $j] ]
            set quicklist [lreplace $quicklist $j $j $y ]
            incr i +1
            incr j -1
        }
    }

    if {$left < $j}  { qs $left $j  }
    if {$right > $j} { qs $i $right }

    return $quicklist
}

proc mc:log {text} {
    putlog "\[06IRC-Arena\] $text"
}

proc mc:logn {nick text} {
    putlog "\[12IRC-Arena:$nick\] $text"
}

###     
proc mc:gainexp {id exp} {
    global mc te

    if { $mc(phase) == 0 } { return 0 }

    set id [mc:makeid $id]
    if { ![info exists te($id)] } { return 0 }

    set maxexp [expr2 0 $mc(gamemaxexp) + $mc(gamemaxexp) * 0.20 * [mc:getstat remort $id]]
    #if { [mc:getstat remort $id] > 0 } {
        set maxexp [expr2 0 $maxexp * [min 1.0 [expr 0.1 + [mc:getstat level $id] * 0.1]]]
    #}

    if { $te($id) >= $maxexp } {
        set te($id) $maxexp
        return $maxexp
    }

    if { [expr2 0 $te($id) + $exp] > $maxexp } {
        set exp [expr2 0 $maxexp - $te($id) ]
    }

    return [set te($id) [expr2 0 $te($id) + $exp]]
}

###  ,      type
proc mc:isbot {type} {
    global mc botnet-nick

    if { ![info exists mc(bot.$type)] }   { return 0 }
    if { ![info exists botnet-nick] }     { return 0 }
    if { $mc(bot.$type) == ${botnet-nick} } { return 1 }

    return 0
}


proc mc:istotal {} {
   global mc
   if { [info exist mc(tot.client)] && $mc(tot.enable) } { return 1 } { return 0 }
}

proc mc:loadscript {h idx t} {
    global arenadir
    global lstr
    global owner

    if {[lsearch -exact [string tolower $owner] [string tolower $h]] == -1 } {
      putidx $idx "negative."
      return
    }
    set lstr ${arenadir}mc.$t.tcl
    putidx $idx "Try load $lstr...\r"
    if {[catch {uplevel #0 {source $lstr}} errstr]} {
        putidx $idx "Err: $errstr\r"
    } else {
       putidx $idx "$lstr sucssefuly loaded.\r"
    }
}

proc mc:misc:loadresult {} {
    global spells thi thicoll mcweather race prof

    set err "[red]*ERR*[cl]"

    if { ![array exist thi] } {
        set c_thi $err
    } {
        set c_thi [expr [array size thi] - 1]
    }
    if { ![array exist spells] } {
        set c_spells $err
    } {
        set c_spells [array size spells]
    }
    if { ![array exist ::arena::affects::affects] } {
        set c_affects $err
    } {
        set c_affects [array size ::arena::affects::affects]
    }
    if { ![array exist thicoll] } {
        set c_thicoll $err
    } {
        set c_thicoll [array size thicoll]
    }
    if { ![array exist mcweather] } {
        set c_weath $err
    } {
        set c_weath [array size mcweather]
    }
    if { ![array exist prof] } {
        set c_prof $err
    } {
        set c_prof [array size prof]
    }
    if { ![array exist race] } {
        set c_race $err
    } {
        set c_race [array size race]
    }

    putlog "-"
    putlog "[grn]Loaded:[cl] Items[hblk]/[cl]$c_thi Collections[hblk]/[cl]$c_thicoll"
    putlog "[grn]Loaded:[cl] Spells[hblk]/[cl]$c_spells Affects[hblk]/[cl]$c_affects Weathers[hblk]/[cl]$c_weath"
    putlog "[grn]Loaded:[cl] Profs[hblk]/[cl]$c_prof Races[hblk]/[cl]$c_race"
    putlog "-"
}


proc mc:loadmodule {m} {
  global arenadir scriptfile; set m2 "${arenadir}mc.${m}."
  if { [file exist ${m2}tbc] } { set scriptfile ${m2}tbc } { set scriptfile ${m2}tcl }
  if {[catch {uplevel #0 {source $scriptfile}} errstr]} {
    putlog "Error while loading module <$m> \($errstr\)\r"
  }
}

proc mc:xloadmodule {m} {
  global arenadir scriptfile
  set scriptfile "${arenadir}mc.x${m}.tcl"
  if { ![file exist $scriptfile] } { 
	 set scriptfile "${arenadir}modules/mc.${m}.tcl"
  }
  if {[catch {uplevel #0 {source $scriptfile}} errstr]} {
    putlog "Error while loading xModule <$m> \($errstr\)\r"
  } {
    if { "[info procs mc:${m}:init]" != "" } { mc:${m}:init }
  }
}

proc mc:backup:init {} {
  bind time - "00 00 * * *" mc:backupbase
  bind time - "00 06 * * *" mc:backupbase
  bind time - "00 12 * * *" mc:backupbase
  bind time - "00 18 * * *" mc:backupbase
}

proc mc:dellogs:init {} {
  bind time - "01 00 * * *" mc:dellogs
}

proc mc:core:init {} {
  global mcbinds
  if {![array exist mcbinds]} { array set mcbinds {} }
}

