#modname wingold
#moddesc        .


proc mc:wingold:init {} {
  global mcwincom mcwinplayer
  
  mc:config:register wintrack      int  5 \
         ,    .
  mc:config:register winmin        int  4 \
              .

  if {![array exist mcwincom]} { array set mcwincom {} }
  if {![array exist mcwinplayer]} { array set mcwinplayer {} }

  set data [mc:config:loadpart "wins"]
  if {$data != ""} {
	 array set mcwincom [lindex $data 0]
    array set mcwinplayer [lindex $data 1]
  }  
  
  mc:bind config_save    wingold      mc:wingold:save
  mc:bind gold_calc      wingold      mc:wingold:calc   
  mc:bind game_end       wingold      mc:wingold:gameend
# mc:bind nick_changeid  wingold      mc:wingold:nickchangeid

#  putlog "Module <WinGold> loaded."
}

#proc mc:wingold:nickchangeid {param} {
#  global mcwinplayer  
#  foreach wtime [array names mcwinplayer] {
#	 if {$mcwinplayer($wtime) == [lindex $param 0]} { set mcwinplayer($wtime) [lindex $param 1] }
#  }	 
#}   

proc mc:wingold:save {fid} {
  global mcwincom mcwinplayer
  mc:config:putstart $fid "wins"
  puts $fid [array get mcwincom]
  puts $fid [array get mcwinplayer]
  mc:config:putend $fid
}    

proc mc:wingold:calc {param} {
  global mcwincom mcwinplayer
  global mcvar

  putlog "Calc Gold:"
  putlog "- gold: $mcvar(gold)"
  putlog "- goldother: $mcvar(goldother)"
  putlog "- wintype: $mcvar(wintype)"
  putlog "- winplayers: $mcvar(winplayers)"
  putlog "- wincom: $mcvar(wincom)"
  putlog "--"
  
  set totalwin 0
  array_init wins
  foreach wtime [array names mcwincom] {
	 set id "!c!$mcwincom($wtime)"
	 if {![info exist wins($id)]} { set wins($id) 0 }
	 incr wins($id)
	 incr totalwin
  }	
  foreach wtime [array names mcwinplayer] {
	 set id "!p!$mcwinplayer($wtime)"
	 if {![info exist wins($id)]} { set wins($id) 0 }
	 incr wins($id)
	 incr totalwin
  }  
  if {$mcvar(wintype) == "single"} {
	 set id "!p![lindex $mcvar(winplayers) 0]"
  } elseif {$mcvar(wintype) == "command"} {
    set id "!c!$mcvar(wincom)"
  } else { return }
  if {![info exist wins($id)]} { set wins($id) 0 }
  putlog "- totalwins: $totalwin"
  putlog "- currentwin: $wins($id)"
  putlog "- totalrecords: [array size wins]"  
}       

proc mc:wingold:gameend {param} {
  global mcwincom mcwinplayer
  global mcvar
  
  if {$mcvar(wintype) == "command"} {
	 set mcwincom([unixtime]) $mcvar(wincom)
  } {
	 set mcwinplayer([unixtime]) [lindex $mcvar(winplayers) 0]
  }
  set tshift [expr [unixtime] - [mc:config:get wintrack] * 60 * 60]
  foreach wtime [array names mcwincom] {
     if {$wtime <= $tshift} { unset mcwincom($wtime) }   
  }
  foreach wtime [array names mcwinplayer] {
     if {$wtime <= $tshift} { unset mcwinplayer($wtime) }   
  }  
}             

